///////////////////////////////////////////////////////////////////////
//ƽ̨ALTERA Cyclone EP1C12Q240C6
//Ƶʣ12MHz
//оƬCH376S
//ڣ2013/10/01
//ʵֹܣ
//1  ʹFPGAӲԿCH376SUSB洢豸U̡SD
//2  ʹоƬĲнӿڣCH376ɳʼοCH376ֲᣩ
//3  USB洢豸ʵּ򵥵ļļд롢ļرյȹܡ
///////////////////////////////////////////////////////////////////////
module	test376(
			pin_a0,				//CH376_A0
			pin_data,			//CH376_D0-D7
			pin_wr,				//CH376_WR#
			pin_rd,				//CH376_RD#
			pin_cs,				//CH376_PCS#ֻǵһоƬֱӽӵأƬѡɸʵ
			pin_int,			//CH376_INT#
			pin_clk,			//FPGA12MHz
			pin_rst,			//FPGAλ
			pin_led				//FPGAָʾƣڼ״̬
			);

//--------port-----------------
output			pin_a0;
inout	[7:0]	pin_data;
output			pin_wr;
output			pin_rd;
output			pin_cs;
input			pin_int;
input			pin_clk;
input			pin_rst;
output	[3:0]	pin_led;

//------output type-----------
reg		[7:0]	reg_tx;
reg				reg_a0;
reg				reg_wr;
reg				reg_rd;
reg				reg_cs;

reg				reg_oe;

assign	pin_data	=	reg_oe?reg_tx:8'hzz;
assign	pin_a0		=	reg_a0;
assign	pin_wr		=	reg_wr;													//ŷʱʹýС4mA
assign	pin_rd		=	reg_rd;													//ŷʱʹýС4mA
assign	pin_cs		=	reg_cs;

//----------------syn-----------
reg		[7:0]	reg_rst_timer;

always	@(posedge pin_clk or negedge pin_rst) begin
	if(!pin_rst)				reg_rst_timer<=8'h80;
	else if(reg_rst_timer[7])	reg_rst_timer<=reg_rst_timer+8'h01;
end
wire	wire_rst	=	reg_rst_timer[7];

reg		reg_div2;
reg		reg_div4;
reg		reg_div8;
reg		reg_div16;
reg		reg_div32;
reg		reg_div64;
reg		reg_div128;

always	@(posedge pin_clk or posedge wire_rst) begin
	if(wire_rst)	reg_div2<=1'b0;
	else			reg_div2<=!reg_div2;
end
always	@(posedge reg_div2 or posedge wire_rst) begin
	if(wire_rst)	reg_div4<=1'b0;
	else			reg_div4<=!reg_div4;
end
always	@(posedge reg_div4 or posedge wire_rst) begin
	if(wire_rst)	reg_div8<=1'b0;
	else			reg_div8<=!reg_div8;
end
always	@(posedge reg_div8 or posedge wire_rst) begin
	if(wire_rst)	reg_div16<=1'b0;
	else			reg_div16<=!reg_div16;
end
always	@(posedge reg_div16 or posedge wire_rst) begin
	if(wire_rst)	reg_div32<=1'b0;
	else			reg_div32<=!reg_div32;
end
always	@(posedge reg_div32 or posedge wire_rst) begin
	if(wire_rst)	reg_div64<=1'b0;
	else			reg_div64<=!reg_div64;
end
always	@(posedge reg_div64 or posedge wire_rst) begin
	if(wire_rst)	reg_div128<=1'b0;
	else			reg_div128<=!reg_div128;
end

reg		reg_clk;

always	@(negedge reg_div2 or posedge wire_rst) begin
	if(wire_rst)			reg_clk<=1'b0;
	else					reg_clk<=reg_div128;
end

wire	wire_clk	=	reg_clk;

reg		[19:0]	reg_ini_wait;
reg					reg_wait;

always	@(posedge reg_div2 or posedge wire_rst) begin
	if(wire_rst)				reg_ini_wait<=20'h80000;
	else if(reg_wait)			reg_ini_wait<=20'h80000;
	else if(reg_ini_wait[19])	reg_ini_wait<=reg_ini_wait+20'h00001;
end
//****************************
reg		reg_int0;
reg		reg_int1;

always	@(posedge wire_clk) begin
	reg_int0<=!pin_int;
end
always	@(posedge wire_clk) begin
	reg_int1<=reg_int0;
end

//****************************
reg		reg_op1;
reg		reg_op2;
reg		reg_op3;
reg		reg_op4;
//reg_op4=1: clkأreg_txźreg_a0̬reg_oeclk½أ״̬reg_statereg_i
//reg_op1=1: clkأ¶дźreg_wrreg_rd
//reg_op2=1: clkأreg_wrreg_rdΪĬֵ1
//reg_op3=1clkأ¶صж״̬reg_err͵ȴжźreg_inc
always	@(posedge wire_clk or posedge wire_rst) begin							
	if(wire_rst)	{reg_op4,reg_op3,reg_op2,reg_op1}<=4'b0000;
	else			{reg_op4,reg_op3,reg_op2,reg_op1}<={reg_op3,reg_op2,reg_op1,!reg_op3&!reg_op2&!reg_op1};
end
//-------------Internal Constant-------------
parameter	WR_IDLE			=	4'b0000;
parameter	WR_CHK1			=	4'b0001;
parameter	SET_USB_MODE	=	4'b0010;
parameter	DISK_CONNECT	=	4'b0011;
parameter	DISK_MOUNT		=	4'b0100;
parameter	CREATE_FILE		=	4'b0101;
parameter	BYTE_WRITE		=	4'b0110;
parameter	WR_REQ_DATA		=	4'b0111;
parameter	BYTE_WR_GO		=	4'b1000;
parameter	CLOSE_FILE		=	4'b1010;
parameter	DISK_DISCONNECT	=	4'b1011;
parameter	WAIT_DISCONNECT	=	4'b1100;

reg		[3:0]	reg_wr_state;
reg		[7:0]	reg_rx;
reg		[7:0]	reg_i;
reg		[7:0]	buffer;
reg		[15:0]	reg_data_cnt;
reg				reg_inc;
reg				reg_err;
reg				reg_go;
reg				reg_i_8;


always	@(negedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	begin reg_wr_state<=WR_IDLE; reg_wait<=1'b0;end
	else if(reg_op4) begin
		case(reg_wr_state)
			WR_IDLE:if(!reg_ini_wait[19])	reg_wr_state<=WR_CHK1;
			WR_CHK1:case(reg_i)
						8'h02:if(!reg_err)	reg_wr_state<=SET_USB_MODE;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h03:if(!reg_err)	reg_wr_state<=DISK_CONNECT;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h03:if(!reg_err)	reg_wr_state<=DISK_MOUNT;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h03:if(!reg_err)	reg_wr_state<=CREATE_FILE;
					endcase
			CREATE_FILE:case(reg_i)
						8'h0d:if(!reg_err)	reg_wr_state<=BYTE_WRITE;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h05:if(!reg_err)	reg_wr_state<=WR_REQ_DATA;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h000:begin end
						9'h001:if(reg_go)			reg_wr_state<=CLOSE_FILE;	//дֽΪʱ˴㣬ֻļȣرļ
						default:if(!reg_err)	reg_wr_state<=BYTE_WR_GO;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h03:begin
							if(reg_go)			reg_wr_state<=WR_REQ_DATA;
							else if(!reg_err)	reg_wr_state<=CLOSE_FILE;
							else				reg_wr_state<=BYTE_WRITE;
						end
					endcase
			CLOSE_FILE:case(reg_i)
						8'h04:if(!reg_err)	reg_wr_state<=DISK_DISCONNECT;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h03:begin
							reg_wr_state<=WAIT_DISCONNECT;
							reg_wait<=1'b1;
						end
					endcase
			WAIT_DISCONNECT:begin
						reg_wait<=1'b0;
						
						if(!reg_ini_wait[19]) begin
							if(reg_err) reg_wr_state<=DISK_DISCONNECT;
							else			reg_wr_state<=DISK_CONNECT;
						end
						else reg_wr_state<=WAIT_DISCONNECT;
					end
		endcase
	end
end

always	@(negedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_cs<=1'b1;
	else case(reg_wr_state)
			WR_CHK1:reg_cs<=1'b0;
		endcase
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	begin reg_tx<=8'h00; reg_data_cnt<=16'h0000;end
	else if(reg_op4) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h00:reg_tx<=8'h06;									//CMD_CHECK_EXIST		0x06	/* Թ״̬ */
						8'h01:reg_tx<=8'h65;									//
					endcase
			SET_USB_MODE:case(reg_i)
						8'h00:reg_tx<=8'h15;									//CMD_SET_USB_MODE		0x15	/* USBģʽ */
						8'h02:reg_tx<=8'h06;									//00H=δõ豸ʽ, 01H=õ豸ʽʹⲿ̼ģʽ(ڲ֧), 02H=õ豸ʽʹù̼ģʽ
																				//03H=SDģʽ/δõģʽ,ڹʹȡSDеļ
																				//04H=δõʽ, 05H=õʽ, 06H=õʽԶSOF, 07H=õʽҸλUSB
					endcase
			DISK_CONNECT:case(reg_i)
						8'h00:reg_tx<=8'h30;									//CMD0H_DISK_CONNECT	0x30	/* ļģʽ/֧SD: Ƿ */
						8'h02:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			DISK_MOUNT:case(reg_i)
						8'h00:reg_tx<=8'h31;									//CMD0H_DISK_MOUNT		0x31	/* ļģʽ: ʼ̲ԴǷ */
						8'h02:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			CREATE_FILE:case(reg_i)
						8'h00:reg_tx<=8'h2f;									//CMD10_SET_FILE_NAME	0x2F	/* ļģʽ: ýҪļļ */
						8'h01:reg_tx<=8'h5c;									//ascii:'\'
						8'h02:reg_tx<=8'h57;									//ascii:'W'
						8'h03:reg_tx<=8'h43;									//ascii:'C'
						8'h04:reg_tx<=8'h48;									//ascii:'H'
						8'h05:reg_tx<=8'h2e;									//ascii:'.'
						8'h06:reg_tx<=8'h54;									//ascii:'T'
						8'h07:reg_tx<=8'h58;									//ascii:'X'
						8'h08:reg_tx<=8'h54;									//ascii:'T'
						8'h09:reg_tx<=8'h00;									//ascii:'NULL'
						8'h0a:reg_tx<=8'h34;									//CMD0H_FILE_CREATE		0x34	/* ļģʽ: ½ļ,ļѾôɾ */
						8'h0c:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			BYTE_WRITE:case(reg_i)
						8'h00:reg_tx<=8'h3c;									//CMD2H_BYTE_WRITE		0x3C	/* ļģʽ: ֽΪλǰλдݿ */
						8'h01:reg_tx<=8'h10;									//ֽ8λ
						8'h02:reg_tx<=8'h04;									//ֽ8λ	
						8'h04:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h000:reg_tx<=8'h2d;									//CMD01_WR_REQ_DATA		0x2D	/* ڲָдݿ */
						9'h001:begin end										//CH376ؿдֽ
						default:begin 
							reg_data_cnt<=reg_data_cnt+16'h0001;				//Ʒֽ
							reg_tx<=buffer;										//			
						end
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h00:reg_tx<=8'h3d;									//CMD0H_BYTE_WR_GO		0x3D	/* ļģʽ: ֽд */
						8'h02:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			CLOSE_FILE:case(reg_i)
						8'h00:begin
							reg_tx<=8'h36;										//CMD1H_FILE_CLOSE		0x36	/* ļģʽ: رյǰѾ򿪵ļĿ¼(ļ) */
							reg_data_cnt<=16'h0000;	
						end
						8'h01:reg_tx<=8'h01;									//00H=ֹ³, 01H=³
						8'h03:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h00:reg_tx<=8'h30;									//CMD0H_DISK_CONNECT	0x30	/* ļģʽ/֧SD: Ƿ */
						8'h02:reg_tx<=8'h22;									//CMD01_GET_STATUS		0x22	/* ȡж״̬ȡж */
					endcase
		endcase
	end
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_wr<=1'b1;
	else if(reg_op2) reg_wr<=1'b1;												//ĬwrΪ1
	else if(reg_op1) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h01:reg_wr<=1'b0;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
					endcase
			CREATE_FILE:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h01:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
						8'h03:reg_wr<=1'b0;
						8'h04:reg_wr<=1'b0;
						8'h05:reg_wr<=1'b0;
						8'h06:reg_wr<=1'b0;
						8'h07:reg_wr<=1'b0;
						8'h08:reg_wr<=1'b0;
						8'h09:reg_wr<=1'b0;
						8'h0a:reg_wr<=1'b0;
						8'h0c:reg_wr<=1'b0;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h01:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
						8'h04:reg_wr<=1'b0;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h001:begin end
						default:reg_wr<=1'b0;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h01:reg_wr<=1'b0;
						8'h03:reg_wr<=1'b0;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h00:reg_wr<=1'b0;
						8'h02:reg_wr<=1'b0;
					endcase
		endcase
	end
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)		reg_oe<=1'b0;
	else if(reg_op4) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h01:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			CREATE_FILE:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h01:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						8'h03:reg_oe<=1'b1;
						8'h04:reg_oe<=1'b1;
						8'h05:reg_oe<=1'b1;
						8'h06:reg_oe<=1'b1;
						8'h07:reg_oe<=1'b1;
						8'h08:reg_oe<=1'b1;
						8'h09:reg_oe<=1'b1;
						8'h0a:reg_oe<=1'b1;
						8'h0c:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h01:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						8'h04:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h001:reg_oe<=1'b0;
						default:reg_oe<=1'b1;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h01:reg_oe<=1'b1;
						8'h03:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h00:reg_oe<=1'b1;
						8'h02:reg_oe<=1'b1;
						default:reg_oe<=1'b0;
					endcase
		endcase
	end
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_rd<=1'b1;
	else if(reg_op2) reg_rd<=1'b1;												//ĬrdΪ1
	else if(reg_op1) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h02:reg_rd<=1'b0;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h03:reg_rd<=1'b0;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h03:reg_rd<=1'b0;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h03:reg_rd<=1'b0;
					endcase
			CREATE_FILE:case(reg_i)
						8'h0d:reg_rd<=1'b0;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h05:reg_rd<=1'b0;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h001:reg_rd<=1'b0;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h03:reg_rd<=1'b0;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h04:reg_rd<=1'b0;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h03:reg_rd<=1'b0;
					endcase
		endcase
	end
end

always	@(posedge reg_rd or posedge wire_rst) begin
	if(wire_rst)	reg_rx<=8'h00;
	else			reg_rx<=pin_data;
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_err<=1'b0;
	else if(reg_op3) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h02:reg_err<=!(reg_rx==8'h9a);						//ȡ
					endcase
			SET_USB_MODE:case(reg_i)
						8'h03:reg_err<=!(reg_rx==8'h51);						//51H:CMD_RET_SUCCESS
					endcase
			DISK_CONNECT:case(reg_i)
						8'h03:reg_err<=!(reg_rx==8'h14);						//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
					endcase
			DISK_MOUNT:case(reg_i)
						8'h03:reg_err<=!(reg_rx==8'h14);						//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
					endcase
			CREATE_FILE:case(reg_i)
						8'h0d:reg_err<=!(reg_rx==8'h14);						//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
					endcase
			BYTE_WRITE:case(reg_i)
						8'h05:reg_err<=!(reg_rx==8'h1e);						//ж״̬USB_INT_DISK_WRITE	0x1E	/* USB洢д */
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h000:begin end
						9'h001:reg_go<=(reg_rx==8'h00);							//CH376ؿдֽΪ
						default:reg_err<=!({reg_i_8,reg_i}==({1'b0,reg_rx}+9'h001));	//CH376ؿдֽ
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h03:begin
							reg_err<=!(reg_rx==8'h14);							//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
							reg_go<=(reg_rx==8'h1e);	
						end
					endcase
			CLOSE_FILE:case(reg_i)
						8'h04:reg_err<=!(reg_rx==8'h14);						//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h03:reg_err<=(reg_rx==8'h14);							//ж״̬USB_INT_SUCCESS		0x14	/* USBߴɹ */
					endcase
		endcase
	end
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_a0<=1'b0;
	else if(reg_op4) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h01:reg_a0<=1'b0;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h01:reg_a0<=1'b0;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h03:reg_a0<=1'b0;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h03:reg_a0<=1'b0;
					endcase
			CREATE_FILE:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h01:reg_a0<=1'b0;
						8'h0a:reg_a0<=1'b1;
						8'h0d:reg_a0<=1'b0;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h01:reg_a0<=1'b0;
						8'h03:reg_a0<=1'b1;
						8'h05:reg_a0<=1'b0;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h000:reg_a0<=1'b1;
						9'h001:reg_a0<=1'b0;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h03:reg_a0<=1'b0;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h01:reg_a0<=1'b0;
						8'h02:reg_a0<=1'b1;
						8'h04:reg_a0<=1'b0;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h00:reg_a0<=1'b1;
						8'h03:reg_a0<=1'b0;
					endcase
		endcase
	end
end

always	@(posedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	reg_inc<=1'b0;												//reg_inc=0ȴжintreg_inc=1ȴж
	else if(reg_op3) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h00:reg_inc<=1'b1;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h00:reg_inc<=1'b1;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h01:reg_inc<=1'b0;
						8'h02:reg_inc<=1'b1;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h01:reg_inc<=1'b0;
						8'h02:reg_inc<=1'b1;
					endcase
			CREATE_FILE:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h0b:reg_inc<=1'b0;
						8'h0c:reg_inc<=1'b1;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h03:reg_inc<=1'b0;
						8'h04:reg_inc<=1'b1;
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h01:reg_inc<=1'b0;
						8'h02:reg_inc<=1'b1;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h02:reg_inc<=1'b0;
						8'h03:reg_inc<=1'b1;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h00:reg_inc<=1'b1;
						8'h01:reg_inc<=1'b0;
						8'h02:reg_inc<=1'b1;
					endcase
		endcase
	end
end

always	@(negedge wire_clk or posedge wire_rst) begin
	if(wire_rst)	begin reg_i<=8'h00;reg_i_8<=1'b0;end
	else if(reg_op4) begin
		case(reg_wr_state)
			WR_CHK1:case(reg_i)
						8'h02:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			SET_USB_MODE:case(reg_i)
						8'h03:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			DISK_CONNECT:case(reg_i)
						8'h03:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			DISK_MOUNT:case(reg_i)
						8'h03:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			CREATE_FILE:case(reg_i)
						8'h0d:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			BYTE_WRITE:case(reg_i)
						8'h05:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			WR_REQ_DATA:case({reg_i_8,reg_i})
						9'h000:reg_i<=reg_i+8'h01;
						9'h001:begin 
							if(reg_go) begin
								reg_i<=8'h00; 
								reg_i_8<=1'b0;
							end
							else 
								reg_i<=reg_i+8'h01;
						end
						9'h0ff:begin 
								reg_i<=8'h00;
								reg_i_8<=1'b1;
						end
						default:begin
							if(!reg_err) begin 
								reg_i<=8'h00;
								reg_i_8<=1'b0;
							end
							else 
								reg_i<=reg_i+8'h01;
						end
					endcase
			BYTE_WR_GO:case(reg_i)
						8'h03:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			CLOSE_FILE:case(reg_i)
						8'h04:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
			DISK_DISCONNECT:case(reg_i)
						8'h03:reg_i<=8'h00;
						default:if(reg_inc|reg_int1) reg_i<=reg_i+8'h01;
					endcase
		endcase
	end
end

always @(reg_data_cnt) begin													//˴д65535ֽ
	case(reg_data_cnt)
		16'h0040:buffer=8'h0d;
		16'h0081:buffer=8'h0d;
		16'h00c2:buffer=8'h0d;
		16'h0103:buffer=8'h0d;
		16'h0144:buffer=8'h0d;
		16'h0185:buffer=8'h0d;
		16'h01c6:buffer=8'h0d;
		16'h0207:buffer=8'h0d;
		16'h0248:buffer=8'h0d;
		16'h0289:buffer=8'h0d;
		16'h02ca:buffer=8'h0d;
		16'h030b:buffer=8'h0d;
		16'h034c:buffer=8'h0d;
		16'h038d:buffer=8'h0d;
		16'h03ce:buffer=8'h0d;
		16'h040f:buffer=8'h0d;													//asciiз
		default:buffer=8'h31;													//ascii'1'
	endcase
end

//****************************
assign	pin_led	=	reg_wr_state;
//****************************

endmodule
